package com.zipcodewilmington.bakery.Services;

import com.zipcodewilmington.bakery.Models.Baker;
import com.zipcodewilmington.bakery.Repositories.BakerRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class BakerService {
    @Autowired
    private BakerRepository bakerRepository;

    public BakerService(){}

    public Iterable<Baker> find() {
        return this.bakerRepository.findAll();
    }

    public Baker findById(Long id) {
        return this.bakerRepository.findById(id).orElse(null);
    }

    public Baker create(Baker baker) {
        return this.bakerRepository.save(baker);
    }

    public Baker update(Long id, Baker baker) {
        Baker foundBaker = bakerRepository.findById(id).orElse(null);

        foundBaker.setName(baker.getName());
        foundBaker.setSpecialty(baker.getSpecialty());

        return this.bakerRepository.save(foundBaker);
    }

    public Boolean destroy(Long id) {
        this.bakerRepository.deleteById(id);
        return true;
    }
}
